Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/TransformingReceptionist.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/TransformingReceptionist.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/core/TransformingReceptionist.java	(revision 24007)
@@ -7,7 +7,10 @@
 import org.w3c.dom.Node; 
 import org.w3c.dom.NodeList; 
+import org.w3c.dom.Comment;
+import org.w3c.dom.Text;
 import org.w3c.dom.Document; 
 import org.w3c.dom.Element;
 import org.xml.sax.InputSource;
+import org.w3c.dom.NamedNodeMap;
 
 // other java classes
@@ -26,4 +29,6 @@
 import org.apache.xerces.dom.*;
 import org.apache.xerces.parsers.DOMParser;
+
+import org.apache.commons.lang3.StringUtils;
 
 /** A receptionist that uses xslt to transform the page_data before returning it. . Receives requests consisting
@@ -81,5 +86,5 @@
   public boolean configure() {
 	
-    if (this.config_params==null) {
+   if (this.config_params==null) {
       logger.error(" config variables must be set before calling configure");
       return false;
@@ -200,8 +205,13 @@
 	else if(excerptTag != null)
 	{
+		/*
         // define a list
         
 		Node selectedElement = modifyNodesByTagRecursive(transformed_page, excerptTag);
+		*/
+		
+		Node selectedElement = getNodeByTagRecursive(transformed_page, excerptTag);
 		return selectedElement;
+		
 	}
 	return transformed_page;
@@ -279,19 +289,128 @@
    * before transforming */
   protected Node transformPage(Element page) {
-
+  	
+	boolean allowsClientXSLT = (Boolean)config_params.get(GSConstants.ALLOW_CLIENT_SIDE_XSLT);
+	//System.out.println("Client side transforms allowed? " + allowsClientXSLT);
+
+	String currentInterface = (String)config_params.get(GSConstants.INTERFACE_NAME);
+
+	Element request = (Element)GSXML.getChildByTagName(page, GSXML.PAGE_REQUEST_ELEM);
+	String output = request.getAttribute(GSXML.OUTPUT_ATT);
+
+	//System.out.println("Current output mode is: " + output + ", current interface name is: " + currentInterface);
+
+	if(allowsClientXSLT) {
+		if(!currentInterface.endsWith(GSConstants.CLIENT_SIDE_XSLT_INTERFACE_SUFFIX) && output.equals("html"))
+		{
+			System.out.println("output is html and we are not currently using a client side version, switching");
+			// Switch the interface
+			config_params.put(GSConstants.INTERFACE_NAME, currentInterface.concat(GSConstants.CLIENT_SIDE_XSLT_INTERFACE_SUFFIX));
+		}
+		else if((currentInterface.endsWith(GSConstants.CLIENT_SIDE_XSLT_INTERFACE_SUFFIX) && !output.equals("html")) || output.equals("server"))
+		{
+			// The reverse needs to happen too
+			config_params.put(GSConstants.INTERFACE_NAME, currentInterface.substring(0, currentInterface.length() - GSConstants.CLIENT_SIDE_XSLT_INTERFACE_SUFFIX.length()));
+		}
+	}
+	else if (currentInterface.endsWith(GSConstants.CLIENT_SIDE_XSLT_INTERFACE_SUFFIX))
+	{
+		config_params.put(GSConstants.INTERFACE_NAME, currentInterface.substring(0, currentInterface.length() - GSConstants.CLIENT_SIDE_XSLT_INTERFACE_SUFFIX.length()));
+	}
+  	
+    // DocType defaults in case the skin doesn't have an "xsl:output" element
+    String qualifiedName = "html";
+    String publicID = "-//W3C//DTD HTML 4.01 Transitional//EN";
+    String systemID = "http://www.w3.org/TR/html4/loose.dtd";
+		
+    // We need to create an empty document with a predefined DocType,
+    // that will then be used for the transformation by the DOMResult
+    Document docWithDoctype = converter.newDOM(qualifiedName, publicID, systemID);		
+		
+	if(output.equals("xsltclient")) {
+	// If you're just getting the client-side transform page, why bother with the rest of this?
+	Element html = docWithDoctype.createElement("html");
+	 Element img = docWithDoctype.createElement("img");
+	 img.setAttribute("src", "interfaces/default/images/loading.gif"); // Make it dynamic
+	 img.setAttribute("alt", "Please wait...");
+	 Text title_text = docWithDoctype.createTextNode("Please wait..."); // Make this language dependent
+	 Element head = docWithDoctype.createElement("head");
+	 Element title = docWithDoctype.createElement("title");
+	 title.appendChild(title_text);
+	 Element body = docWithDoctype.createElement("body");
+	 Element script = docWithDoctype.createElement("script");
+	 Element jquery = docWithDoctype.createElement("script");
+	 jquery.setAttribute("src", "jquery.js");
+	 jquery.setAttribute("type", "text/javascript");
+	 Comment jquery_comment = docWithDoctype.createComment("jQuery");
+	 Comment script_comment = docWithDoctype.createComment("Filler for browser");
+	 script.setAttribute("src", "test.js");
+	 script.setAttribute("type", "text/javascript");
+	 Element pagevar = docWithDoctype.createElement("script");
+	 Element style = docWithDoctype.createElement("style");
+	 style.setAttribute("type", "text/css");
+	 Text style_text = docWithDoctype.createTextNode("body { text-align: center; padding: 50px; font: 14pt Arial, sans-serif; font-weight: bold; }");
+	 pagevar.setAttribute("type", "text/javascript");
+	 Text page_var_text = docWithDoctype.createTextNode("var placeholder = true;");
+	 
+	 html.appendChild(head);
+	 head.appendChild(title);
+	 head.appendChild(style);
+	 style.appendChild(style_text);
+	 html.appendChild(body);
+	 head.appendChild(pagevar);
+	 head.appendChild(jquery);
+	 head.appendChild(script);
+	 pagevar.appendChild(page_var_text);
+	 jquery.appendChild(jquery_comment);
+	 script.appendChild(script_comment);
+	 body.appendChild(img);
+	 docWithDoctype.appendChild(html);
+	 
+	 return (Node)docWithDoctype;
+	 }
+
+    // Passing in the pretty string here means it needs to be generated even when not debugging; so use custom function to return blank when debug is off
     logger.debug("page before transforming:");
-    logger.debug(this.converter.getPrettyString(page));
-
-    Element request = (Element)GSXML.getChildByTagName(page, GSXML.PAGE_REQUEST_ELEM);
+    logger.debug(this.converter.getPrettyStringLogger(page, logger));
+
     String action = request.getAttribute(GSXML.ACTION_ATT);
     String subaction = request.getAttribute(GSXML.SUBACTION_ATT);
-		
-    String output = request.getAttribute(GSXML.OUTPUT_ATT);
+
     // we should choose how to transform the data based on output, eg diff
     // choice for html, and wml??
     // for now, if output=xml, we don't transform the page, we just return 
     // the page xml
-    if (output.equals("xml")) {
-      return page;
+    Document theXML = null;
+    
+    if (output.equals("xml") || output.equals("clientside")) {
+      // Append some bits and pieces first...
+      theXML = converter.newDOM();
+      // Import into new document first!
+      Node newPage = theXML.importNode(page, true);
+      theXML.appendChild(newPage);
+      Element root = theXML.createElement("xsltparams");
+      newPage.appendChild(root);
+      
+      Element libname = theXML.createElement("param");
+      libname.setAttribute("name", "library_name");
+      Text libnametext = theXML.createTextNode((String)config_params.get(GSConstants.LIBRARY_NAME));
+      libname.appendChild(libnametext);
+      
+      Element intname = theXML.createElement("param");
+      intname.setAttribute("name", "interface_name");
+      Text intnametext = theXML.createTextNode((String)config_params.get(GSConstants.INTERFACE_NAME));
+      intname.appendChild(intnametext);
+	  
+	  Element filepath = theXML.createElement("param");
+	  filepath.setAttribute("name", "filepath");
+	  Text filepathtext = theXML.createTextNode(GlobalProperties.getGSDL3Home());
+	  filepath.appendChild(filepathtext);
+      
+      root.appendChild(libname);
+      root.appendChild(intname);   
+	  root.appendChild(filepath);
+      
+      if(output.equals("xml"))
+      return theXML.getDocumentElement();
     }
 		
@@ -300,5 +419,6 @@
     String collection = "";
     if (cgi_param_list != null) {
-      HashMap params = GSXML.extractParams(cgi_param_list, false);
+      // Don't waste time getting all the parameters
+      HashMap params = GSXML.extractParams(cgi_param_list, false, GSParams.COLLECTION);
       collection = (String)params.get(GSParams.COLLECTION);
       if (collection == null) collection = "";
@@ -314,6 +434,5 @@
     String errorPage = this.converter.getParseErrorMessage();
     if(errorPage != null) {
-      return XMLTransformer.constructErrorXHTMLPage(
-						    "Cannot parse the xslt file: " + xslt_file + "\n" + errorPage);
+      return XMLTransformer.constructErrorXHTMLPage("Cannot parse the xslt file: " + xslt_file + "\n" + errorPage);
     }
     if (style_doc == null) {
@@ -335,12 +454,13 @@
     if (format_elem != null) {
       //page_response.removeChild(format_elem);
-      logger.debug("format elem="+this.converter.getPrettyString(format_elem));
+      logger.debug("format elem="+this.converter.getPrettyStringLogger(format_elem, logger));
       // need to transform the format info
       String configStylesheet_file = GSFile.stylesheetFile(GlobalProperties.getGSDL3Home(), (String)this.config_params.get(GSConstants.SITE_NAME), collection, (String)this.config_params.get(GSConstants.INTERFACE_NAME), base_interfaces,   "config_format.xsl");
       Document configStylesheet_doc = this.converter.getDOM(new File(configStylesheet_file));
+
       if (configStylesheet_doc != null) {
 	Document format_doc = this.converter.newDOM();
 	format_doc.appendChild(format_doc.importNode(format_elem, true));
-	Node result = this.transformer.transform(configStylesheet_doc, format_doc);
+	Node result = this.transformer.transform(configStylesheet_doc, format_doc); // Needs addressing <-
 				
 	// Since we started creating documents with DocTypes, we can end up with 
@@ -353,5 +473,5 @@
 	  new_format = (Element)result;
 	}
-	logger.debug("new format elem="+this.converter.getPrettyString(new_format));
+	logger.debug("new format elem="+this.converter.getPrettyStringLogger(new_format, logger));
 	if (output.equals("newformat")) {
 	  return new_format;
@@ -370,5 +490,5 @@
       }
       logger.debug("the converted stylesheet is:");
-      logger.debug(this.converter.getPrettyString(style_doc.getDocumentElement()));
+      logger.debug(this.converter.getPrettyStringLogger(style_doc.getDocumentElement(), logger));
     }
 		
@@ -377,5 +497,5 @@
 
 
-    Document preprocessingXsl  ;
+    Document preprocessingXsl;
     try {
       preprocessingXsl = getPreprocessDoc();
@@ -537,15 +657,25 @@
       return converter.getDOM(getStringFromDocument(skinAndLibraryXsl));
     }
-    if (output.equals("skinandlibdoc")) {
-      return converter.getDOM(getStringFromDocument(skinAndLibraryDoc));
+    if (output.equals("skinandlibdoc") || output.equals("clientside")) { 	
+    	
+    	Node skinAndLib = converter.getDOM(getStringFromDocument(skinAndLibraryDoc));
+    	
+    	if(output.equals("skinandlibdoc")) {
+      return skinAndLib;
+       } else {
+       	// Send XML and skinandlibdoc down the line together
+       	Document finalDoc = converter.newDOM();
+       	Node finalDocSkin = finalDoc.importNode(skinAndLibraryDoc.getDocumentElement(), true);
+       	Node finalDocXML = finalDoc.importNode(theXML.getDocumentElement(), true);
+       	Element root = finalDoc.createElement("skinlibPlusXML");
+       	root.appendChild(finalDocSkin);
+       	root.appendChild(finalDocXML);
+       	finalDoc.appendChild(root);
+       	return (Node)finalDoc.getDocumentElement();
+       }
     }
     if (output.equals("oldskindoc")) {
       return converter.getDOM(getStringFromDocument(oldStyle_doc));
     }
-
-    // DocType defaults in case the skin doesn't have an "xsl:output" element
-    String qualifiedName = "html";
-    String publicID = "-//W3C//DTD HTML 4.01 Transitional//EN";
-    String systemID = "http://www.w3.org/TR/html4/loose.dtd";
 
     // Try to get the system and public ID from the current skin xsl document
@@ -571,22 +701,19 @@
     }
 		
-    // We need to create an empty document with a predefined DocType,
-    // that will then be used for the transformation by the DOMResult
-    Document docWithDoctype = converter.newDOM(qualifiedName, publicID, systemID);
-		
     //System.out.println(converter.getPrettyString(docWithDoctype));
     //System.out.println("Doctype vals: " + qualifiedName + " " + publicID + " " + systemID) ;
 		
+	 docWithDoctype = converter.newDOM(qualifiedName, publicID, systemID);			
 		
     //System.out.println("Generate final HTML from current skin") ;
     //Transformation of the XML message from the receptionist to HTML with doctype
-    return this.transformer.transform(skinAndLibraryDoc, doc, config_params, docWithDoctype);
-		
-		
+
+    return this.transformer.transform(skinAndLibraryDoc, doc, config_params, docWithDoctype); // The default
+	
     // The line below will do the transformation like we use to do before having Skin++ implemented,
     // it will not contain any GS-Lib statements expanded, and the result will not contain any doctype.
 
     //return (Element)this.transformer.transform(style_doc, doc, config_params);  
-
+	//return null; // For now - change later
   }
 	
@@ -606,5 +733,5 @@
 	content = writer.toString();
 	System.out.println("Change the & to &Amp; for proper debug dispay") ;
-	content = content.replaceAll("&", "&amp;");
+	content = StringUtils.replace(content, "&", "&amp;");
 	writer.flush();
       }
@@ -657,7 +784,7 @@
     String stylesheet = GSFile.stylesheetFile(GlobalProperties.getGSDL3Home(), (String)this.config_params.get(GSConstants.SITE_NAME), collection, (String)this.config_params.get(GSConstants.INTERFACE_NAME), base_interfaces, name);
     if (stylesheet==null) {
-      logger.info(" cant find stylesheet for "+name);
-    }
-    logger.error("stylesheet:"+stylesheet);
+      logger.info(" Can't find stylesheet for "+name);
+    }
+    logger.debug("Stylesheet: "+stylesheet);
     return stylesheet;
   }
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2DocumentRetrieve.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2DocumentRetrieve.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/AbstractGS2DocumentRetrieve.java	(revision 24007)
@@ -44,4 +44,7 @@
 import org.apache.log4j.*;
 
+// Apache Commons
+import org.apache.commons.lang3.*;
+
 /** Implements the generic retrieval and classifier services for GS2 
  * collections.
@@ -150,5 +153,5 @@
 	StringTokenizer st = new StringTokenizer(contains, ";");
 	while (st.hasMoreTokens()) {
-	    String child_id = st.nextToken().replaceAll("\"", node_id);
+	    String child_id = StringUtils.replace(st.nextToken(), "\"", node_id);
 	    children.add(child_id);
 	}
@@ -235,5 +238,5 @@
 	    
 	    String contains = info.getInfo("contains");
-	    contains = contains.replaceAll("\"", parent_id);
+	    contains = StringUtils.replace(contains, "\"", parent_id);
 	    String [] children = contains.split(";");
 	    for (int i=0;i<children.length;i++) {
@@ -475,5 +478,5 @@
 		} else {
 		    String contains = info.getInfo("contains");
-		    contains = contains.replaceAll("\"", parent_id);
+		    contains = StringUtils.replace(contains, "\"", parent_id);
 		    String [] children = contains.split(";");
 		    for (int i=0;i<children.length;i++) {
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/BerryBasket.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/BerryBasket.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/BerryBasket.java	(revision 24007)
@@ -449,5 +449,4 @@
 
     protected Element processDisplayList(Element request) {
-	// Create a new (empty) result message
      	Hashtable docsMap =  updateDocMap(request);
 
@@ -457,14 +456,14 @@
         Iterator keys = docsMap.keySet().iterator();
 	
-         while(keys.hasNext()){     
-	     String collection = (String)keys.next(); 
-             Hashtable items = (Hashtable)docsMap.get(collection);
-	     Iterator itemItr = items.values().iterator();
-
-             Element collectionNode = this.doc.createElement("collection");
-             collectionNode.setAttribute("name",collection);
-	     result.appendChild(collectionNode);
-
-	     while(itemItr.hasNext()){  
+	while(keys.hasNext()){     
+	    String collection = (String)keys.next(); 
+	    Hashtable items = (Hashtable)docsMap.get(collection);
+	    Iterator itemItr = items.values().iterator();
+	    
+	    Element collectionNode = this.doc.createElement("berryList");
+	    collectionNode.setAttribute("name",collection);
+	    result.appendChild(collectionNode);
+	    
+	    while(itemItr.hasNext()){  
                 Item item = (Item)itemItr.next();
 	        Element itemElement = this.doc.createElement("item");
@@ -476,10 +475,10 @@
 		itemElement.setAttribute("date",item.date);
                	itemElement.setAttribute("root_title",item.rootTitle);                
- 	     }	     
-	 }
+	    }	     
+	}
        
 	return result;
 
-   }
+    }
 
 
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/GS2MGRetrieve.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/GS2MGRetrieve.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/GS2MGRetrieve.java	(revision 24007)
@@ -33,4 +33,7 @@
 
 import org.apache.log4j.*;
+
+// Apache Commons
+import org.apache.commons.lang3.*;
 
 public class GS2MGRetrieve
@@ -134,5 +137,5 @@
         if (doc_content!=null) {
             // remove any ctrl-c or ctrl-b
-            doc_content = doc_content.replaceAll ("\u0002|\u0003", "");
+            doc_content = StringUtils.replace(doc_content, "\u0002|\u0003", "");
             // replace _httpimg_ with the correct address
             doc_content = resolveTextMacros (doc_content, doc_id, lang);
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/OAIPMH.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/OAIPMH.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/service/OAIPMH.java	(revision 24007)
@@ -253,14 +253,14 @@
 
     ArrayList keys = new ArrayList(info.getKeys());
-    String lastmodified = "";
-    if(keys.contains(OAIXML.LASTMODIFIED)) {
-      lastmodified = info.getInfo(OAIXML.LASTMODIFIED);
-    }
-    lastmodified = OAIXML.getTime(Long.parseLong(lastmodified));
+    String oailastmodified = "";
+    if(keys.contains(OAIXML.OAI_LASTMODIFIED)) {
+      oailastmodified = info.getInfo(OAIXML.OAI_LASTMODIFIED);
+      oailastmodified = OAIXML.getTime(Long.parseLong(oailastmodified)*1000); // java wants dates in milliseconds
+    }
 
     Element get_record = OAIXML.createElement(OAIXML.GET_RECORD);
     Element record = OAIXML.createElement(OAIXML.RECORD);
     //compose the header element
-    record.appendChild(createHeaderElement(oid, lastmodified));      
+    record.appendChild(createHeaderElement(oid, oailastmodified));      
     //compose the metadata element
     record.appendChild(createMetadataElement(prefix, info, metadata_format));
@@ -332,11 +332,11 @@
       }
       ArrayList keys = new ArrayList(info.getKeys());
-      String lastmodified = "";
-      if(keys.contains(OAIXML.LASTMODIFIED)) {
-        lastmodified = info.getInfo(OAIXML.LASTMODIFIED);
-      }
-      lastmodified = OAIXML.getTime(Long.parseLong(lastmodified));
+      String oailastmodified = "";
+      if(keys.contains(OAIXML.OAI_LASTMODIFIED)) {
+        oailastmodified = info.getInfo(OAIXML.OAI_LASTMODIFIED);
+	oailastmodified = OAIXML.getTime(Long.parseLong(oailastmodified)*1000); // java wants dates in milliseconds
+      }
       
-      Date this_date = OAIXML.getDate(lastmodified);        
+      Date this_date = OAIXML.getDate(oailastmodified);        
       if (from_date != null) {
         if(this_date.before(from_date)) {
@@ -350,5 +350,5 @@
       }      
       //compose the header element and append it
-      list_identifiers.appendChild(createHeaderElement(oid, lastmodified));      
+      list_identifiers.appendChild(createHeaderElement(oid, oailastmodified));      
     }//end of for(int i=0; i<oid_list.size(); i++) of doing thru each record
     
@@ -418,11 +418,11 @@
       }
       ArrayList keys = new ArrayList(info.getKeys());
-      String lastmodified = "";
-      if(keys.contains(OAIXML.LASTMODIFIED)) {
-        lastmodified = info.getInfo(OAIXML.LASTMODIFIED);
-      }
-      lastmodified = OAIXML.getTime(Long.parseLong(lastmodified));
+      String oailastmodified = "";
+      if(keys.contains(OAIXML.OAI_LASTMODIFIED)) {
+        oailastmodified = info.getInfo(OAIXML.OAI_LASTMODIFIED);
+	oailastmodified = OAIXML.getTime(Long.parseLong(oailastmodified)*1000); // java wants dates in milliseconds
+      }
       
-      Date this_date = OAIXML.getDate(lastmodified);        
+      Date this_date = OAIXML.getDate(oailastmodified);        
       if (from_date != null) {
         if(this_date.before(from_date)) {
@@ -439,5 +439,5 @@
       list_records.appendChild(record);
       //compose the header element
-      record.appendChild(createHeaderElement(oid, lastmodified));      
+      record.appendChild(createHeaderElement(oid, oailastmodified));      
       //compose the metadata element
       record.appendChild(createMetadataElement(prefix, info, metadata_format));
@@ -501,5 +501,5 @@
   /** create a header element used when processing requests like ListRecords/GetRecord/ListIdentifiers
    */
-  private Element createHeaderElement(String oid, String lastmodified) {    
+  private Element createHeaderElement(String oid, String oailastmodified) {    
         Element header = OAIXML.createElement(OAIXML.HEADER);
         Element identifier = OAIXML.createElement(OAIXML.IDENTIFIER);
@@ -510,5 +510,5 @@
         header.appendChild(set_spec);
         Element datestamp = OAIXML.createElement(OAIXML.DATESTAMP);
-        GSXML.setNodeText(datestamp, lastmodified);
+        GSXML.setNodeText(datestamp, oailastmodified);
         header.appendChild(datestamp);
         return header;
@@ -656,4 +656,7 @@
 <contains>".1;".2;".3;".4;".5;".6;".7;".8;".9
 <docnum>349
+<oailastmodified>1303283795
+<lastmodifieddate>20110412
+<oailastmodifieddate>20110420
 ----------------------------------------------------------------------
      */
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GS2MacroResolver.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GS2MacroResolver.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GS2MacroResolver.java	(revision 24007)
@@ -24,4 +24,9 @@
 import java.net.URLDecoder;
 
+// Apache Commons
+import org.apache.commons.lang3.*;
+
+import java.util.Stack;
+
 public class GS2MacroResolver 
     extends MacroResolver
@@ -29,4 +34,6 @@
 
     protected SimpleCollectionDatabase coll_db = null;
+
+    private static Pattern p_back_slash = Pattern.compile("\\\"");// create a pattern "\\\"", but it matches both " and \"
     
     // need to make it not add macros if they are already present
@@ -58,13 +65,14 @@
 	} 
 
-	ArrayList macros;
+	Stack macros = new Stack();//ArrayList macros;
 	if (scope.equals(SCOPE_TEXT)) {
-	    macros = text_macros;
+	    macros.addAll(text_macros);
 	} else {
-	    macros = metadata_macros;
+	    macros.addAll(metadata_macros);
 	}
-	for (int i=0; i<macros.size(); i++) {
+	//for (int i=0; i<macros.size(); i++) {
+	while(!macros.empty()) {
 	    String new_text = null;
-	    Macro m = (Macro)macros.get(i);
+	    Macro m = (Macro)macros.pop();//.get(i);
 	    switch (m.type) {
 	    case TYPE_DICT:
@@ -76,5 +84,5 @@
 		// otherwise we can't cache the answer because it might be 
 		// document specific
-		text = text.replaceAll(m.macro, m.text);
+		text = StringUtils.replace(text, m.macro, m.text);
 		break;
 	    case TYPE_TEXT:
@@ -83,7 +91,11 @@
 		// doesn't necessarily match line breaks
 		//if (text.matches("(?s).*"+m.macro+".*")) {
-		Pattern p_text = Pattern.compile(".*" + m.macro + ".*",Pattern.DOTALL);
-		Matcher match_text = p_text.matcher(text);
-		if (match_text.matches()) {
+		
+		/*Pattern p_text = Pattern.compile(".*" + m.macro + ".*",Pattern.DOTALL);
+		Matcher match_text = p_text.matcher(text);*/
+
+		// sm252
+		// String.contains is far faster than regex!
+		if (text.contains(m.macro)) { //match_text.matches()) { //text.matches("(?s).*"+m.macro+".*")) {
 		    if (m.resolve) {
 			new_text = this.resolve(m.text, lang, scope, doc_oid);
@@ -91,7 +103,7 @@
 			new_text = m.text;
 		    }
-		    text = text.replaceAll(m.macro, new_text);
+		    text = StringUtils.replace(text, m.macro, new_text);
 		    if (m.macro.endsWith("\\\\")){ // to get rid of "\" from the string likes: "src="http://www.greenstone.org:80/.../mw.gif\">"
-			Pattern p_back_slash = Pattern.compile("\\\"");// create a pattern "\\\"", but it matches both " and \"
+			
 			Matcher m_slash = p_back_slash.matcher(text);
 			String clean_str = "";
@@ -111,7 +123,8 @@
 		break;
 	    case TYPE_META:
-		Pattern p = Pattern.compile(".*" + m.macro + ".*",Pattern.DOTALL);
-		Matcher match = p.matcher(text);
-		if (match.matches()) {
+		//Pattern p = Pattern.compile(".*" + m.macro + ".*",Pattern.DOTALL);
+		//Matcher match = p.matcher(text);
+		// sm252
+		if (text.contains(m.macro)) { //(match.matches()) { //text.matches("(?s).*"+m.macro+".*")) {
 		    if (node_info == null) {
 			node_info = coll_db.getInfo(doc_oid);
@@ -133,5 +146,5 @@
 			    new_text = this.resolve(new_text, lang, scope, doc_oid);
 			}
-			text = text.replaceAll(m.macro, new_text);
+			text =  StringUtils.replace(text, m.macro, new_text);
 		    }
 		    
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GSConstants.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GSConstants.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GSConstants.java	(revision 24007)
@@ -27,5 +27,6 @@
     public static final String LIBRARY_NAME = "library_name";
     public static final String DEFAULT_LANG = "default_lang";
-
+	public static final String ALLOW_CLIENT_SIDE_XSLT = "allow_client_side_xslt";
+	public static final String CLIENT_SIDE_XSLT_INTERFACE_SUFFIX = "-client-xslt";
 
     public static final String META_RELATION_SEP = "_";
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GSParams.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GSParams.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GSParams.java	(revision 24007)
@@ -50,4 +50,5 @@
     public static final String EXPAND_DOCUMENT = "ed";
     public static final String EXPAND_CONTENTS = "ec";
+	public static final String REALISTIC_BOOK = "book";
 
   // used for filtering out a piece of the final page
@@ -80,4 +81,6 @@
 	addParameter(EXPAND_DOCUMENT, false);
 	addParameter(EXPAND_CONTENTS, false);
+	addParameter(REALISTIC_BOOK, false);	
+	
  	//addParameter();
 	// ugly hack so we don't save the extlink param
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java	(revision 24007)
@@ -264,8 +264,12 @@
   }
   
+  public static HashMap extractParams(Element xml, boolean deep) {
+	return extractParams(xml, deep, null);
+  }
+
   /** takes a paramList element, and gets a HashMap of name-value pairs
    * if deep=true, extracts embedded params, otherwise just top level
    * params*/
-  public static HashMap extractParams(Element xml, boolean deep) {
+  public static HashMap extractParams(Element xml, boolean deep, String toFind) {
     
     if (!xml.getNodeName().equals(PARAM_ELEM+LIST_MODIFIER)) {
@@ -286,4 +290,13 @@
         String name=param.getAttribute(NAME_ATT);
         String value=getValue(param); //att or content
+
+	// For only one parameter
+	if(toFind != null && name.equals(toFind)) {
+		param_map.put(name, value);
+		return param_map;
+	}		
+	else if(toFind != null)
+		continue;
+
         int pos = name.indexOf('.');
         if (pos == -1) { // a base param
@@ -674,4 +687,9 @@
   public static void addParametersToList(Document owner, Element param_list,
     HashMap params) {
+	if (params == null)
+	{
+		return;
+	}
+	
     Set items = params.entrySet();
     Iterator i = items.iterator();
